﻿using UnityEngine;
using System.Collections;

public class Button : MonoBehaviour {

	public Vector2 respawnPoint;
	public AudioClip clickSound;

	private Transform trigger;
	private bool pressed = false;
	public bool isGoal = false;

	private const float pressedPosition = 0.06f;
	private const float defaultPosition = 0.315f;

	void Start() {
		trigger = transform.Find("trigger");
	}

	void Update() {
		float localY = trigger.localPosition.y;
		localY = Mathf.MoveTowards(localY, pressed ? pressedPosition : defaultPosition, 3.0f * Time.deltaTime);
		trigger.localPosition = new Vector3(trigger.localPosition.x, localY, 0.0f);
	}

	void OnTriggerEnter2D(Collider2D other)
	{
		Player player = other.GetComponent<Player>();
		if (player != null) {
			pressed = true;
			audio.PlayOneShot(clickSound);
			if (isGoal) {
				GameManager.Instance.NextObstacle();
				player.respawnPoint = respawnPoint;
				isGoal = false;
				trigger.GetComponent<SpriteRenderer>().color = new Color(0.5f, 0.5f, 0.5f, 1.0f);
			}
		}
	}

	void OnTriggerExit2D(Collider2D other)
	{
		Player player = other.GetComponent<Player>();
		if (player != null) {
			pressed = false;
		}
	}
}
